#include "StdAfx.h"
#include "Capusb_Main.h"
#include <stdio.h>
#include <commctrl.h>
#include <shlwapi.h>
#include "resource.h"

#pragma comment(lib,"lib/cyapi.lib")
#pragma comment(lib,"shlwapi.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"winmm.lib")

extern LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

CCapUSB_Main::CCapUSB_Main()
{
	m_hInst=NULL;
	m_hWnd=NULL;
	m_hStatusBar=NULL;
	m_pDTV=NULL;

	m_bDeviceConnect=FALSE;
	m_bThreadActive=FALSE;
	m_bPacketFilter=FALSE;
	ZeroMemory(&m_stStreamProc,sizeof(struct ThreadInfo));
	ZeroMemory(&m_stStreamInfo,sizeof(struct TS_StreamInfo));
	m_pStreamBuf=NULL;
	m_pTsStream=NULL;
	m_pFileRecord=NULL;
	m_pNetworkSend=NULL;
	m_pChannelWnd=NULL;
	m_pFilterWnd=NULL;
	m_pScheduleRec=NULL;
	m_dwFileRecEndTick=0;

	m_wTsStreamOutput_Schedule=0;
	
	// VXe^C}擾(̕@œlmǂ͂ȂƂ॥)
	m_pMMTimerPeriod=NULL;
	{
		DWORD dwTimeAdjustment;
		DWORD dwTimeIncrement;
		BOOL bTimeAdjustmentDisabled;
		GetSystemTimeAdjustment(&dwTimeAdjustment,&dwTimeIncrement,&bTimeAdjustmentDisabled);
		m_dTimerClock=(double)dwTimeIncrement / 10000.0;
		timeGetDevCaps(&m_stTimeCaps,sizeof(TIMECAPS));	
	}

	InitCommonControls();

	InitializeCriticalSection(&m_csGUI);
	InitializeCriticalSection(&m_csServiceList);
}

CCapUSB_Main::~CCapUSB_Main(void)
{
	if(m_pDTV) delete m_pDTV;
	if(m_pStreamBuf) delete m_pStreamBuf;
	if(m_pTsStream) delete m_pTsStream;
	if(m_pFileRecord) delete m_pFileRecord;
	if(m_pNetworkSend) delete m_pNetworkSend;

	DeleteCriticalSection(&m_csGUI);
	DeleteCriticalSection(&m_csServiceList);
}

int CCapUSB_Main::Main(HINSTANCE hInstance)
{
	m_hInst=hInstance;

	m_pStreamBuf=new CBufferMT(10*1024*1024);

	// NpX̌sIvVt@Ci[
	GetCurrentDirectory(MAX_PATH,m_szOptionFile);
	PathAddBackslash(m_szOptionFile);
	lstrcpy(m_szScheduleFile,m_szOptionFile);
	lstrcat(m_szOptionFile,CAPUSB_OPTION_FILENAME);
	lstrcat(m_szScheduleFile,CAPUSB_SCHEDULE_FILENAME);

	OptionIO(FALSE);
	DialogBoxParam(m_hInst,MAKEINTRESOURCE(IDD_CAPUSB),NULL,(DLGPROC)CapUSB_MainDlg,(LPARAM)this);	
	OptionIO(TRUE);
	
	return 0;
}

LRESULT CALLBACK CCapUSB_Main::CapUSB_MainDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
#pragma warning(disable: 4312)
	CCapUSB_Main* pThis=(CCapUSB_Main*)GetWindowLongPtr(hDlg,GWL_USERDATA);
#pragma warning(default: 4312)

	switch (message)
	{
	case WM_INITDIALOG:
		{
			pThis=(CCapUSB_Main*)lParam;
			pThis->m_hWnd=hDlg;
#pragma warning(disable: 4311)
			SetWindowLongPtr(hDlg,GWL_USERDATA,(LONG)pThis);
#pragma warning(default: 4311)
			return pThis->OnInitDialog();
		}
		break;
	case WM_COMMAND:
		return pThis->OnCommand(wParam,lParam);
		break;
	case WM_USER:
		return pThis->OnUser(wParam,lParam);
		break;
	}
	return FALSE;
}

BOOL CCapUSB_Main::OnInitDialog()
{
	BOOL bFirstFlg;
	if(!m_pDTV)
	{
		m_pDTV=new CDTV_EzUSBFX2();
		if(!m_pDTV) return FALSE;
		if(!m_pDTV->Initialize("",m_hWnd,NULL)) return FALSE;
	}
	if(!m_pDTV)
	{
//		m_pDTV=new CDTV_Friio();
//		if(!m_pDTV) return FALSE;
//		if(!m_pDTV->Initialize("BonDriver.dll",m_hWnd,NULL)) return FALSE;	
	}
	if(!m_pDTV)
	{
//		m_pDTV=new CDTV_EzUSBFX2_Direct_HvMikitty();
//		if(!m_pDTV) return FALSE;
//		if(!m_pDTV->Initialize("",m_hWnd,NULL)) return FALSE;
	}
	if(!m_pDTV)
	{
//		m_pDTV=new CDTV_OptCUsb2();
//		if(!m_pDTV) return FALSE;
//		if(!m_pDTV->Initialize("",m_hWnd,NULL)) return FALSE;
	}
	if(!m_pDTV)
	{
//		m_pDTV=new CDTV_FileIn();
//		if(!m_pDTV) return FALSE;
//		if(!m_pDTV->Initialize("\\\\cosmos\\capture\\ts\\ۑ\\20080410-1443-WOWWOW(Í).ts",m_hWnd,NULL)) return FALSE;
	}

	if(!m_pDTV) return FALSE;

	if(m_stOpt.iPosX<=-30000||m_stOpt.iPosY<=-30000)
	{
		RECT rcRect;
		GetWindowRect(m_hWnd,&rcRect);
		m_stOpt.iPosX=rcRect.left;
		m_stOpt.iPosY=rcRect.top;
	} else {
		SetWindowPos(m_hWnd,0,m_stOpt.iPosX,m_stOpt.iPosY,0,0,SWP_NOSIZE|SWP_NOZORDER);
	}

	CheckDlgButton(m_hWnd,IDC_HV_MIKITTY_INIT	,m_stOpt.bHvMikittyInit);
	CheckDlgButton(m_hWnd,IDC_B25				,m_stOpt.bARIB_B25);
	SetDlgItemInt(m_hWnd,IDC_RECTIME			,m_stOpt.iRecTime,FALSE);

	SetDlgItemText(m_hWnd,IDC_NETWORK_ADDRESS	,m_stOpt.szNetworkAddress);
	SetDlgItemInt(m_hWnd,IDC_NETWORK_PORT		,m_stOpt.iNetworkPort,FALSE);
	SetDlgItemInt(m_hWnd,IDC_NETWORK_PACKET_SIZE,m_stOpt.iNetworkSendSize,FALSE);

	// Status Bar
	int iStatusBarSize[] = {50,105,250,-1};	// B-CAS | W^掞 | W^掞Ԏc | \^
	m_hStatusBar = CreateWindowEx(0,STATUSCLASSNAME,NULL,WS_CHILD|WS_VISIBLE|CCS_BOTTOM,0,0,0,0,m_hWnd,(HMENU)IDC_STATUS,m_hInst,NULL);
	if(m_hStatusBar)
	{
		SendMessage(m_hStatusBar,SB_SETPARTS,4,(LPARAM)iStatusBarSize);
	}

	// `lݒEBhE(Modeless)
	bFirstFlg = FALSE;
	m_pChannelWnd = new CChannelWnd(m_pDTV);
	if(m_stOpt.iChPosX<=-30000||m_stOpt.iChPosY<=-30000)
	{
		m_stOpt.iChPosX=0;
		m_stOpt.iChPosY=0;
		bFirstFlg = TRUE;
	}
	m_pChannelWnd->Create(m_hInst,IDD_CHANNEL,m_hWnd,bFirstFlg,m_stOpt.iChPosX,m_stOpt.iChPosY,0,0,m_stOpt.bShowChWnd?SW_SHOW:SW_HIDE);

	// tB^OEBhE(Modeless)
	bFirstFlg = FALSE;
	m_pFilterWnd = new CFilterWnd(m_hInst);
	m_pFilterWnd->SetFilterCallback(OnSetFilter,this);
	if(m_stOpt.iFiltPosX<=-30000||m_stOpt.iFiltPosY<=-30000)
	{
		m_stOpt.iFiltPosX=0;
		m_stOpt.iFiltPosY=0;
		bFirstFlg = TRUE;
	}
	m_pFilterWnd->Create(m_hInst,IDD_FILTER,m_hWnd,bFirstFlg,m_stOpt.iFiltPosX,m_stOpt.iFiltPosY,m_stOpt.iFiltSizeX,m_stOpt.iFiltSizeY,m_stOpt.bShowFiltWnd?SW_SHOW:SW_HIDE);

	// \^
	m_pScheduleRec = new CScheduleRec(m_pDTV);
	if(m_stOpt.iSchePosX<=-30000||m_stOpt.iSchePosY<=-30000)
	{
		m_stOpt.iSchePosX=0;
		m_stOpt.iSchePosY=0;
		bFirstFlg = TRUE;
	}
	m_pScheduleRec->Create(m_hInst,IDD_SCHEDUE,m_hWnd,bFirstFlg,m_stOpt.iSchePosX,m_stOpt.iSchePosY,m_stOpt.iScheSizeX,m_stOpt.iScheSizeY,m_stOpt.bShowScheduleWnd?SW_SHOW:SW_HIDE);
	m_pScheduleRec->LoadSchedule(m_szScheduleFile);
	m_pScheduleRec->SetRecPath(m_stOpt.szAutoPath);

	OnRefleshBtn();
	return TRUE;
}

BOOL CCapUSB_Main::OnCommand(WPARAM wParam,LPARAM lParam)
{
	switch(LOWORD(wParam))
	{
	case IDCANCEL:
	case IDM_EXIT:
		if(!m_bDeviceConnect)
		{
			RECT rcRect;
			GetWindowRect(m_hWnd,&rcRect);
			m_stOpt.bHvMikittyInit	= (IsDlgButtonChecked(m_hWnd,IDC_HV_MIKITTY_INIT	)==BST_CHECKED?TRUE:FALSE);
			m_stOpt.bARIB_B25		= (IsDlgButtonChecked(m_hWnd,IDC_B25				)==BST_CHECKED?TRUE:FALSE);			
			m_stOpt.iPosX=rcRect.left;
			m_stOpt.iPosY=rcRect.top;
			if(m_pChannelWnd)
			{
				m_pChannelWnd->Destroy(&m_stOpt.iChPosX,&m_stOpt.iChPosY,NULL,NULL,&m_stOpt.bShowChWnd);
				m_stOpt.iLastSelCh = m_pChannelWnd->GetLastSelctChannel();
				delete m_pChannelWnd;
				m_pChannelWnd = NULL;
			}
			if(m_pFilterWnd)
			{
				m_pFilterWnd->Destroy(&m_stOpt.iFiltPosX,&m_stOpt.iFiltPosY,&m_stOpt.iFiltSizeX,&m_stOpt.iFiltSizeY,&m_stOpt.bShowFiltWnd);
				delete m_pFilterWnd;
				m_pFilterWnd = NULL;
			}
			if(m_pScheduleRec)
			{
				m_pScheduleRec->Destroy(&m_stOpt.iSchePosX,&m_stOpt.iSchePosY,&m_stOpt.iScheSizeX,&m_stOpt.iScheSizeY,&m_stOpt.bShowScheduleWnd);
				m_pScheduleRec->SaveSchedule(m_szScheduleFile);
				delete m_pScheduleRec;
				m_pScheduleRec = NULL;
			}
			if(m_hStatusBar)
			{
				DestroyWindow(m_hStatusBar);
				m_hStatusBar = NULL;
			}
			EndDialog(m_hWnd,0);
		} else {
			MessageBox(m_hWnd,"ڑ͏Ił܂B","capusb",MB_OK);
		}
		break;
	case IDC_DEVICE:
		if(HIWORD(wParam)==CBN_SELCHANGE) OnSelchangeDeviceListCombox();
		break;
	case IDC_REFLESH:
		OnRefleshBtn();
		break;
	case IDC_CONNECT:
		OnConnect();
		break;
	case IDC_FILE_RECORD:
		OnFileRecord();
		break;
	case IDC_RECTIME_ADD_10MIN:
		{
			if(m_pFileRecord&&m_pFileRecord->IsOpen())
			{
				if(m_dwFileRecEndTick>0)
				{
					m_dwFileRecEndTick+=10*60*1000;
				}
			} else {
				BOOL bGetRet;
				DWORD dwVal=GetDlgItemInt(m_hWnd,IDC_RECTIME,&bGetRet,FALSE);
				dwVal+=10;
				SetDlgItemInt(m_hWnd,IDC_RECTIME,dwVal,FALSE);
			}
		}
		break;
	case IDC_NETWORK_SEND:
		OnNetworkSend();
		break;
	case IDM_CHANNEL:
		OnChannel();
		break;
	case IDM_FILTER:
		OnFilter();
		break;
	case IDM_SCHEDULE:
		OnSchedule();
		break;
	case IDM_CLEAR:
		{
			if(m_pDTV) m_pDTV->ClearTransferInfo();
			m_stStreamInfo.dwTsSyncFail=0;
			m_stStreamInfo.dwTsPacketDrop=0;
			m_stStreamInfo.dwScramblePacket=0;

			m_stStreamInfo.dwRecieveBufferOverflow=0;
			m_stStreamInfo.dwSyncBufferOverflow=0;
			m_stStreamInfo.dwStreamBufferOverflow=0;
		}
		break;
	case IDM_OPTION:
		if(OnOptionDlg())
		{
			if(m_pScheduleRec) m_pScheduleRec->SetRecPath(m_stOpt.szAutoPath);
		}
		break;
	case IDM_ABOUT:
		DialogBoxParam(m_hInst,MAKEINTRESOURCE(IDD_ABOUTBOX),m_hWnd,(DLGPROC)About,0);
		break;
	}
	return TRUE;
}

BOOL CCapUSB_Main::OnUser(WPARAM wParam,LPARAM lParam)
{
	switch(LOWORD(wParam))
	{
	case 1:
		{
			OnDrawXferResult(&m_stStreamInfo);
		}
		break;
	}
	return TRUE;
}

void CCapUSB_Main::OnRefleshBtn()
{
	EnterCriticalSection(&m_csGUI);
	SendDlgItemMessage(m_hWnd,IDC_DEVICE,CB_RESETCONTENT,0,0);
	int n=m_pDTV->GetDeviceCount();
	if(n>0)
	{
		int i;
		for(i=0;i<n;i++)
		{
			char buf[80];
			if(m_pDTV->GetDeviceName(i,buf,80))
			{
				LRESULT iPos=SendDlgItemMessage(m_hWnd,IDC_DEVICE,CB_ADDSTRING,0,(LPARAM)buf);
			}
		}
		SendDlgItemMessage(m_hWnd,IDC_DEVICE,CB_SETCURSEL,0,0);
		EnableWindow(GetDlgItem(m_hWnd,IDC_DEVICE),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_CONNECT),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_FILE_RECORD),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_SEND),FALSE);
		OnFileRecord(TRUE);
		OnNetworkSend(TRUE);
		if(m_pFilterWnd) m_pFilterWnd->Reset();
		OnDrawXferResult(&m_stStreamInfo);
		OnSelchangeDeviceListCombox();
	} else {
		EnableWindow(GetDlgItem(m_hWnd,IDC_DEVICE),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_CONNECT),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_IN),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_OUT),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_FILE_RECORD),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_SEND),FALSE);
		OnFileRecord(TRUE);
		OnNetworkSend(TRUE);
		if(m_pFilterWnd) m_pFilterWnd->Reset();
		OnDrawXferResult(&m_stStreamInfo);
	}
	CDTV_EzUSBFX2 *pCapUSB=dynamic_cast<CDTV_EzUSBFX2*>(m_pDTV);
	if(!pCapUSB)
	{
		CDTV_EzUSBFX2_Direct_HvMikitty *pCapUSB2=dynamic_cast<CDTV_EzUSBFX2_Direct_HvMikitty*>(m_pDTV);
		if(!pCapUSB2)
		{
			EnableWindow(GetDlgItem(m_hWnd,IDC_HV_MIKITTY_INIT),FALSE);
			ShowWindow(GetDlgItem(m_hWnd,IDC_HV_MIKITTY_INIT),SW_HIDE);
		}
	}
	LeaveCriticalSection(&m_csGUI);
}

void CCapUSB_Main::OnSelchangeDeviceListCombox()
{
	int i,n,nIn=0,nOut=0;
	LRESULT nVal;
	int iDevice=(int)SendDlgItemMessage(m_hWnd,IDC_DEVICE,CB_GETCURSEL,0,0);
	if(iDevice==CB_ERR)
	{
		return;
	}
	SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_IN,CB_RESETCONTENT,0,0);
	SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_RESETCONTENT,0,0);
	// o̓Gh|Cg
	nVal=SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_ADDSTRING,0,(LPARAM)"Ȃ");
	SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_SETITEMDATA,nVal,0xffff);
	nOut++;

	n=m_pDTV->GetUsbEndpointCount(iDevice);
	for(i=0;i<n;i++)
	{
		struct DTV_UsbEndpointInfo stUsbEP;
		if(m_pDTV->GetUsbEndpointInfo(iDevice,i,&stUsbEP))
		{
			// BulkModẽGh|Cĝ
			if(stUsbEP.Attributes==2)
			{
				char buf[10];
				wsprintf(buf,"0x%02X",stUsbEP.Address);
				if(stUsbEP.Address&0x80)
				{
					nIn++;
					nVal=SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_IN,CB_ADDSTRING,0,(LPARAM)buf);
					SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_IN,CB_SETITEMDATA,nVal,stUsbEP.Address);
				} else {
					nOut++;
					nVal=SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_ADDSTRING,0,(LPARAM)buf);
					SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_SETITEMDATA,nVal,stUsbEP.Address);
				}
			}
		}
	}
	// OIĂ̂đI
	if(nIn>0)
	{
		SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_IN,CB_SETCURSEL,nIn-1,0);
		for(i=0;i<nIn;i++)
		{
			nVal=SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_IN,CB_GETITEMDATA,i,0);
			if(m_stOpt.iLastInEP==nVal)
			{
				SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_IN,CB_SETCURSEL,i,0);
			}
		}
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_IN),TRUE);
	} else {
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_IN),FALSE);
	}
	if(nOut>0)
	{
		SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_SETCURSEL,nOut-1,0);
		for(i=0;i<nOut;i++)
		{
			nVal=SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_GETITEMDATA,i,0);
			if(m_stOpt.iLastOutEP==nVal)
			{
				SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_SETCURSEL,i,0);
			}
		}
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_OUT),TRUE);
	} else {
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_OUT),FALSE);
	}
}

void CCapUSB_Main::OnConnect()
{
	EnterCriticalSection(&m_csGUI);
	if(!m_bDeviceConnect)
	{		
		// ڑ
		struct StreamProcThreadParam *lpstStreamProc=NULL;
		try
		{
			lpstStreamProc=new struct StreamProcThreadParam;
			int iDevice,iSel;

			// Thread Param
			ZeroMemory(lpstStreamProc,sizeof(struct StreamProcThreadParam));
			lpstStreamProc->lpClassPtr=this;
			m_stStreamProc.hExitEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
			
			iDevice=(int)SendDlgItemMessage(m_hWnd,IDC_DEVICE,CB_GETCURSEL,0,0);
			if(iDevice==CB_ERR) throw 1;
			m_stOpt.bHvMikittyInit=(IsDlgButtonChecked(m_hWnd,IDC_HV_MIKITTY_INIT)==BST_CHECKED?TRUE:FALSE);

			// B25
			if(IsDlgButtonChecked(m_hWnd,IDC_B25)==BST_CHECKED)
			{
				lpstStreamProc->pB25 = new CB25();
				if(!lpstStreamProc->pB25)
				{
					MessageBox(m_hWnd,"Can not init B25 class.","Error",MB_OK);
					throw 101;
				}
				if(!lpstStreamProc->pB25->Open("B25Decoder.dll"))
				{
					MessageBox(m_hWnd,"B25Decord.dll init error.","Error",MB_OK);
				}
				if(!lpstStreamProc->pB25->Initialize())
				{
					MessageBox(m_hWnd,"B-CAS card error","Error",MB_OK);
					throw 104;
				}
				// EMMȂRgO
				/*				
				if(!lpstStreamProc->pB25->Ext_ProcEmm(TRUE))
				{
					MessageBox(m_hWnd,"Can not surpport EMM proc","Error",MB_OK);
					throw 105;
				}
				*/
			}

			// IGh|CgAhX擾
			iSel=(int)SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_IN,CB_GETCURSEL,0,0);
			if(iSel==CB_ERR) throw 2;
			int iIn=(int)SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_IN,CB_GETITEMDATA,iSel,0);
			iSel=(int)SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_GETCURSEL,0,0);
			if(iSel==CB_ERR) throw 3;
			int iOut=(int)SendDlgItemMessage(m_hWnd,IDC_ENDPOINT_OUT,CB_GETITEMDATA,iSel,0);

			if(!m_pDTV->IsEndpointEffective(iDevice,iIn))
			{
				MessageBox(m_hWnd,"EPwG[","Error",MB_OK);
				throw 22;
			}

			// s
			if(m_stOpt.bHvMikittyInit)
			{
				if(!m_pDTV->IsEndpointEffective(iDevice,iOut))
				{
					MessageBox(m_hWnd,"HvMikittyɂ͏oEPKvł","Error",MB_OK);
					throw 23;
				}
			}

			// MMTimer
			if(m_stOpt.iTimerPeriod>0)
			{
				m_pMMTimerPeriod = new CMMTimerPeriod(m_stOpt.iTimerPeriod,5);
			}

			// Buffer
			m_pStreamBuf->Clear();

			// CallbackZbg
			m_pDTV->SetCallbackFunc(DTVRecieveCallback,this);

			// 
			CDTV_EzUSBFX2 *pCapUSB=dynamic_cast<CDTV_EzUSBFX2*>(m_pDTV);
			if(pCapUSB)
			{
				pCapUSB->SetHvMikittyInit(m_stOpt.bHvMikittyInit);
			}
			CDTV_EzUSBFX2_Direct_HvMikitty *pCapUSB2=dynamic_cast<CDTV_EzUSBFX2_Direct_HvMikitty*>(m_pDTV);
			if(pCapUSB2)
			{
				pCapUSB2->SetHvMikittyInit(m_stOpt.bHvMikittyInit);
			}

			// Open
			m_pDTV->Connect(iDevice,iIn,iOut);

			// `lXgXV
			if(m_pChannelWnd)
			{
				m_pChannelWnd->UpdateChannelList(FALSE,m_stOpt.iLastSelCh);
				m_pChannelWnd->SetEnable(TRUE);
			}
			// T[rXXgL
			if(m_pFilterWnd) m_pFilterWnd->SetEnable(TRUE);

			// `lݒ
			if(m_pDTV->GetExtFunction() & DTV_EXTFUNC_CHSEL)
			{
				m_pDTV->SetChannel(m_stOpt.iLastSelCh);
			}

			// Thread
			m_stStreamProc.hThread=CreateThread(NULL,0,StreamProcThread,lpstStreamProc,CREATE_SUSPENDED,&m_stStreamProc.dwThreadID);
			if(!m_stStreamProc.hThread) throw 10;
			// Priority(lq)
//			SetThreadPriority(m_stStreamProc.hThread,m_stOpt.iThreadPriorityProc);
//			m_pDTV->SetThreadPriority(m_stOpt.iThreadPriorityReq,m_stOpt.iThreadPriorityRes);		
			// Jn
			m_bThreadActive=TRUE;
			ResumeThread(m_stStreamProc.hThread);
		}
		catch(int err_code)
		{
			CATCH_INT_ERROR_CODE(err_code);
			if(lpstStreamProc)
			{
				if(lpstStreamProc->pB25) delete lpstStreamProc->pB25;
				delete lpstStreamProc;
			}
			m_pDTV->DisConnect();
			if(m_pMMTimerPeriod)
			{
				delete m_pMMTimerPeriod;
				m_pMMTimerPeriod=NULL;
			}

			CloseHandle(m_stStreamProc.hThread);
			CloseHandle(m_stStreamProc.hExitEvent);
			ZeroMemory(&m_stStreamProc,sizeof(struct ThreadInfo));
			CheckDlgButton(m_hWnd,IDC_CONNECT,BST_UNCHECKED);
			return;
		}		

		EnableWindow(GetDlgItem(m_hWnd,IDC_DEVICE),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_REFLESH),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_IN),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_OUT),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_HV_MIKITTY_INIT),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_FILE_RECORD),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_SEND),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_B25),FALSE);
		m_bDeviceConnect=TRUE;
	} else {
		// `lXg폜
		if(m_pChannelWnd)
		{
			m_stOpt.iLastSelCh = m_pDTV->GetChannel();
			m_pChannelWnd->UpdateChannelList(TRUE,0);
			m_pChannelWnd->SetEnable(FALSE);
		}

		// T[rXXg
		if(m_pFilterWnd) m_pFilterWnd->SetEnable(FALSE);

		// DTVؒf
		m_pDTV->DisConnect();

		// ؒf
		DWORD dwThreadExitCode;
		// XbhIv(10sec҂ď߂Ȃ΋I)
		SetEvent(m_stStreamProc.hExitEvent);
		m_bThreadActive=FALSE;
		if(WAIT_OBJECT_0!=WaitForSingleObject(m_stStreamProc.hThread,10*1000))
		{
			TerminateThread(m_stStreamProc.hThread,-1);
		}
		GetExitCodeThread(m_stStreamProc.hThread,&dwThreadExitCode);

		// ^/UDPM~
		ZeroMemory(&m_stStreamInfo,sizeof(struct TS_StreamInfo));
		OnFileRecord(TRUE);
		OnNetworkSend(TRUE);
		if(m_pFilterWnd) m_pFilterWnd->Reset();

		// MMTimer
		if(m_pMMTimerPeriod)
		{
			delete m_pMMTimerPeriod;
			m_pMMTimerPeriod=NULL;
		}

		CloseHandle(m_stStreamProc.hThread);
		CloseHandle(m_stStreamProc.hExitEvent);
		ZeroMemory(&m_stStreamProc,sizeof(struct ThreadInfo));

		EnableWindow(GetDlgItem(m_hWnd,IDC_DEVICE),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_REFLESH),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_IN),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_ENDPOINT_OUT),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_HV_MIKITTY_INIT),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_FILE_RECORD),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_SEND),FALSE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_B25),TRUE);
		m_bDeviceConnect=FALSE;
	}
	LeaveCriticalSection(&m_csGUI);
}

// t@C^
void CCapUSB_Main::OnFileRecord(BOOL bForceClose)
{
	EnterCriticalSection(&m_csGUI);
	if(bForceClose||m_pFileRecord)
	{
		// ^~
		EnableWindow(GetDlgItem(m_hWnd,IDC_RECTIME),TRUE);
		CheckDlgButton(m_hWnd,IDC_FILE_RECORD,BST_UNCHECKED);
		SetDlgItemText(m_hWnd,IDC_FILE_RECORD,"^Jn");
		m_dwFileRecEndTick=0;
		if(m_pFileRecord)
		{
			delete m_pFileRecord;
			m_pFileRecord=NULL;
		}
		OnDrawXferResult(&m_stStreamInfo);
	} else {
		// ^Jn
		BOOL bFlg=TRUE;
		char szPath[MAX_PATH]="",buf[80];
		m_pFileRecord=new CFileRecord(FILE_WRITE_BLOCK_SIZE);
		if(!m_pFileRecord) return;
		if(m_stOpt.bAutoFilename)
		{
			// t@C
			lstrcpy(szPath,m_stOpt.szAutoPath);
			if(GetFileAttributes(szPath)==INVALID_FILE_ATTRIBUTES)
			{
				MessageBox(m_hWnd,"","capusb",MB_OK);
				bFlg=FALSE;
			}
			PathAddBackslash(szPath);

			SYSTEMTIME stTime;
			GetLocalTime(&stTime);
			wsprintf(buf,"cap-%04d%02d%02d-%02d%02d%02d.ts",
				stTime.wYear,stTime.wMonth,stTime.wDay,
				stTime.wHour,stTime.wMinute,stTime.wSecond);
			PathAppend(szPath,buf);

		} else {
			// t@CI
			if(!m_pFileRecord->GetRecordFileName(m_hWnd,szPath,MAX_PATH))
			{
				bFlg=FALSE;
			}
		}
		if(bFlg&&!m_pFileRecord->Open(szPath))
		{			
			bFlg=FALSE;
		}
		if(bFlg)
		{
			BOOL bGetRet;
			m_stOpt.iRecTime=GetDlgItemInt(m_hWnd,IDC_RECTIME,&bGetRet,FALSE);
			EnableWindow(GetDlgItem(m_hWnd,IDC_RECTIME),FALSE);
			CheckDlgButton(m_hWnd,IDC_FILE_RECORD,BST_CHECKED);
			SetDlgItemText(m_hWnd,IDC_FILE_RECORD,"^~");
			if(m_stOpt.iRecTime>0)
			{
				m_dwFileRecEndTick=GetTickCount()+(m_stOpt.iRecTime*60*1000);
			} else {
				m_dwFileRecEndTick=0;
			}
		} else {
			MessageBox(m_hWnd,"JnɎs܂","capusb",MB_OK);
			if(m_pFileRecord) delete m_pFileRecord;
			m_pFileRecord=NULL;
			EnableWindow(GetDlgItem(m_hWnd,IDC_RECTIME),TRUE);
			CheckDlgButton(m_hWnd,IDC_FILE_RECORD,BST_UNCHECKED);
			m_dwFileRecEndTick=0;
		}
	}
	LeaveCriticalSection(&m_csGUI);
}

// lbg[NzM
void CCapUSB_Main::OnNetworkSend(BOOL bForceClose)
{
	EnterCriticalSection(&m_csGUI);
	if(bForceClose||m_pNetworkSend)
	{
		// M~
		CheckDlgButton(m_hWnd,IDC_NETWORK_SEND,BST_UNCHECKED);
		SetDlgItemText(m_hWnd,IDC_NETWORK_SEND,"MJn");
		EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_ADDRESS),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_PORT),TRUE);
		EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_PACKET_SIZE),TRUE);
		if(m_pNetworkSend)
		{
			delete m_pNetworkSend;
			m_pNetworkSend=NULL;
		}
	} else {
		// MJn
		BOOL bGetRet;
		GetDlgItemText(m_hWnd,IDC_NETWORK_ADDRESS,m_stOpt.szNetworkAddress,MAX_PATH);
		m_stOpt.iNetworkPort=GetDlgItemInt(m_hWnd,IDC_NETWORK_PORT,&bGetRet,FALSE);
		m_stOpt.iNetworkSendSize=GetDlgItemInt(m_hWnd,IDC_NETWORK_PACKET_SIZE,&bGetRet,FALSE);

		m_pNetworkSend=new CNetworkSend(m_stOpt.iNetworkSendSize);
		if(!m_pNetworkSend) return;

		if(!m_pNetworkSend->Open(m_stOpt.szNetworkAddress,(WORD)m_stOpt.iNetworkPort))
		{
			// s
			MessageBox(m_hWnd,"JnɎs܂","capusb",MB_OK);
			CheckDlgButton(m_hWnd,IDC_NETWORK_SEND,BST_UNCHECKED);
			delete m_pNetworkSend;
			m_pNetworkSend=NULL;
		} else {
			// 
			CheckDlgButton(m_hWnd,IDC_NETWORK_SEND,BST_CHECKED);
			SetDlgItemText(m_hWnd,IDC_NETWORK_SEND,"M~");
			EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_ADDRESS),FALSE);
			EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_PORT),FALSE);
			EnableWindow(GetDlgItem(m_hWnd,IDC_NETWORK_PACKET_SIZE),FALSE);
		}		
	}
	LeaveCriticalSection(&m_csGUI);
}

void CCapUSB_Main::OnChannel()
{
	EnterCriticalSection(&m_csGUI);
	if(m_pChannelWnd)
	{
		if(m_pChannelWnd->IsWindowVisible())
		{
			m_pChannelWnd->ShowWindow(SW_HIDE);
		} else {
			m_pChannelWnd->ShowWindow(SW_SHOW);
		}
	}
	LeaveCriticalSection(&m_csGUI);
}

void CCapUSB_Main::OnFilter()
{
	EnterCriticalSection(&m_csGUI);
	if(m_pFilterWnd)
	{
		if(m_pFilterWnd->IsWindowVisible())
		{
			m_pFilterWnd->ShowWindow(SW_HIDE);
		} else {
			m_pFilterWnd->ShowWindow(SW_SHOW);
		}
	}
	LeaveCriticalSection(&m_csGUI);
}

void CCapUSB_Main::OnSchedule()
{
	EnterCriticalSection(&m_csGUI);
	if(m_pScheduleRec)
	{
		if(m_pScheduleRec->IsWindowVisible())
		{
			m_pScheduleRec->ShowWindow(SW_HIDE);
		} else {
			m_pScheduleRec->ShowWindow(SW_SHOW);
		}
	}
	LeaveCriticalSection(&m_csGUI);
}

// ʃACe`
void CCapUSB_Main::OnDrawXferResult(struct TS_StreamInfo *lpstStreamInfo)
{
	DateTime stCurrentTime={0,0};
	char buf[80],buf2[80];	

	struct DTV_TransferInfo stInfo;
	if(m_pDTV)
	{
		m_pDTV->GetTransferInfo(&stInfo);
	} else {		
		ZeroMemory(&stInfo,sizeof(struct DTV_TransferInfo));
	}

	DWORD dwTime=(GetTickCount()-stInfo.dwStartTick)/1000;

	// Stream
	if(dwTime<60)
	{
		wsprintf(buf,"%d",dwTime);
	} else {
		wsprintf(buf,"%d:%02d",dwTime/60,dwTime%60);
	}
	SetDlgItemText(m_hWnd,IDC_TIME,buf);
	wsprintf(buf,"%u",stInfo.dwSuccess);
	SetDlgItemText(m_hWnd,IDC_SUCCESS,buf);
	wsprintf(buf,"%u",stInfo.dwFail);
	SetDlgItemText(m_hWnd,IDC_FAIL,buf);
	double dSpeed=lpstStreamInfo->dSpeed*8;
	sprintf(buf,"%.2lf Mbps",dSpeed/1024/1024);
	SetDlgItemText(m_hWnd,IDC_SPEED,buf);
	if(m_pDTV)
	{	
		m_pDTV->GetDeviceInfoText(buf,128);
	}
	SetDlgItemText(m_hWnd,IDC_DEVICE_INFO,buf);

	// Buffer
	wsprintf(buf,"%dKB/%dKB\nR:%d Sy:%d St:%d",
		m_pStreamBuf->GetDataSize()/1024,m_pStreamBuf->GetBufferSize()/1024,
		m_stStreamInfo.dwRecieveBufferOverflow,m_stStreamInfo.dwSyncBufferOverflow,m_stStreamInfo.dwStreamBufferOverflow);
	SetDlgItemText(m_hWnd,IDC_BUFFER,buf);
	// TS
	wsprintf(buf,"%u",lpstStreamInfo->wTsPacketLen);
	SetDlgItemText(m_hWnd,IDC_TS_PACKET_LEN,buf);
	wsprintf(buf,"%u",lpstStreamInfo->dwTsSyncFail);
	SetDlgItemText(m_hWnd,IDC_TS_SYNC_ERROR,buf);
	wsprintf(buf,"%u",lpstStreamInfo->dwTsPacketDrop);
	SetDlgItemText(m_hWnd,IDC_TS_PACKET_DROP,buf);
	wsprintf(buf,"%u",lpstStreamInfo->dwScramblePacket);
	SetDlgItemText(m_hWnd,IDC_TS_SCRAMBLE,buf);

	// Xg[^CX^v(擪*tf[^͎MMԂ̂́AȂ̂͂̎Ԃ̃ItZbg)
	if(lpstStreamInfo->stCurrentTime.stDateTime.Date>0)
	{
		DWORD dwTick=GetTickCount()-lpstStreamInfo->stCurrentTime.dwGetTick;
		stCurrentTime=lpstStreamInfo->stCurrentTime.stDateTime;
		if(dwTick>1000)
		{
			CDateTime::OffsetDateTime(stCurrentTime,dwTick/1000);
		}
		long y,m,d,h,mn,s;
		CDateTime::ConvertFrom_MJD(stCurrentTime.Date,y,m,d);
		CDateTime::ConvertFrom_TimeSec(stCurrentTime.Time,h,mn,s);
		wsprintf(buf,"%c%04d/%02d/%02d\n%02d:%02d:%02d",dwTick<1000?'*':' ',y,m,d,h,mn,s);
	} else {
		buf[0]='\0';
	}
	SetDlgItemText(m_hWnd,IDC_TS_TIME,buf);

	// ^
	if(m_pFileRecord)
	{
		unsigned __int64 size=m_pFileRecord->GetWriteTotalSize();
		if(size>0)
		{
			wsprintf(buf,"^撆 %I64u MByte",size/1024/1024);
		} else {
			wsprintf(buf,"^obt@");
		}
	} else {
		wsprintf(buf,"^~");
	}
	SetDlgItemText(m_hWnd,IDC_FILE_REC_SIZE,buf);

	// ^󂫗e
	if(m_pFileRecord&&m_pFileRecord->IsOpen())
	{
		ULARGE_INTEGER ui64Free=m_pFileRecord->GetFreeSize();
		wsprintf(buf," %I64u MByte",ui64Free.QuadPart/1024/1024);
		if(ui64Free.QuadPart<=RECORD_STOP_DISK_FREE)
		{
			// ^fBXNeʂȂ̂Ř^~
			OnFileRecord(TRUE);
			MessageBox(m_hWnd,"^fBXNeʂȂ̂Ř^~܂B","ERROR",MB_OK);
		}
		else if(ui64Free.QuadPart<=RECORD_WARNING_DISK_FREE)
		{
			// ^fBXNeʂȂȂĂ̂Ōx()
		}
	} else {
		wsprintf(buf," ");
	}
	SetDlgItemText(m_hWnd,IDC_DISK_FREE_SPACE,buf);
	
	// Status Bar
	// B25
	buf[0]='\0';
	if(lpstStreamInfo->bB25Proc)
	{
		if(lpstStreamInfo->bB25Extend)
		{
			// B25DecordergAPI					
			wsprintf(buf,"%d.%d.%d",lpstStreamInfo->stB25Ver.byMajor,lpstStreamInfo->stB25Ver.byMinor,lpstStreamInfo->stB25Ver.byBuild);
		} else {
			// B25DecorderW
			lstrcpy(buf,"B25 ON");
		}
	}
	SendMessage(m_hStatusBar,SB_SETTEXT,0,(LPARAM)buf);

	// ^掞ԂƘ^c莞
	if(m_pFileRecord&&m_pFileRecord->IsOpen())
	{
		DWORD dwOpenTime=m_pFileRecord->GetOpenTick()/1000;
		if(m_dwFileRecEndTick>0)
		{
			DWORD dwCurrent=GetTickCount();
			DWORD dwTime=m_dwFileRecEndTick-dwCurrent;
			if(dwTime>0&&m_dwFileRecEndTick>dwCurrent)
			{
				dwTime/=1000;
				wsprintf(buf ,"%d:%02d",dwOpenTime/60,dwOpenTime%60);
				wsprintf(buf2,"%d:%02d Ɏ~",dwTime/60,dwTime%60);
			} else {
				OnFileRecord(TRUE);
				wsprintf(buf," ");
				wsprintf(buf2,"~");
			}
		} else {
			wsprintf(buf ,"%d:%02d",dwOpenTime/60,dwOpenTime%60);
			wsprintf(buf2,"^掩~ݒȂ",dwOpenTime/60,dwOpenTime%60);
		}
	} else {
		wsprintf(buf," ");
		wsprintf(buf2," ");
	}
	SendMessage(m_hStatusBar,SB_SETTEXT,1,(LPARAM)buf);
	SendMessage(m_hStatusBar,SB_SETTEXT,2,(LPARAM)buf2);

	// lbg[NM
	if(m_pNetworkSend)
	{
		unsigned __int64 size=m_pNetworkSend->GetSendTotalSize();
		BYTE byIpAddr[4];
		m_pNetworkSend->GetIpAddress(byIpAddr);
		if(size>0)
		{
			wsprintf(buf,"M(%d.%d.%d.%d) %I64u MByte",byIpAddr[0],byIpAddr[1],byIpAddr[2],byIpAddr[3],size/1024/1024);
		} else {
			wsprintf(buf,"Mobt@");
		}
	} else {
		wsprintf(buf,"M~");
	}
	SetDlgItemText(m_hWnd,IDC_NETWORK_SEND_SIZE,buf);
	
	wsprintf(buf," ");
	if(m_pTsStream)
	{
		// tB^EBhEEPG
		if(m_pFilterWnd && stCurrentTime.Date>0)
		{
			m_pFilterWnd->SetCurrentEPG(stCurrentTime);
		}
		// ^\
		if(m_pScheduleRec)
		{			
			if(!m_stOpt.bUseSystemTime)
			{
				if(stCurrentTime.Date>0)
				{
					m_pScheduleRec->PutCurrentTime(stCurrentTime);
					m_pScheduleRec->GetStatusString(buf,80);
				}
			}
			else
			{
				DateTime stCurrent=CDateTime::GetCurrentDateTime();
				m_pScheduleRec->PutCurrentTime(stCurrent);
				m_pScheduleRec->GetStatusString(buf,80);
			}			
		}
		// EPG-DB
		CTsEPGMgr *pEpg = m_pTsStream->GetEpgMgr();
		if(pEpg)
		{
			pEpg->DeleteEpgDataByTime(stCurrentTime);
		}
	}
	SendMessage(m_hStatusBar,SB_SETTEXT,3,(LPARAM)buf);
}

// UITS߂lf[^𔽉f
void CCapUSB_Main::TsCallbackUI(UINT uType,WORD wStreamID,LPVOID pData,DWORD dwVal,LPVOID lpContext)
{
	switch(uType)
	{
	case TSENG_CALLBACK_TIME_RECIEVE:
		{
			struct TAG_TSCB_TIME *pstTime = (struct TAG_TSCB_TIME*)pData;
			m_stStreamInfo.stCurrentTime.dwGetTick=GetTickCount();
			m_stStreamInfo.stCurrentTime.stDateTime=pstTime->stDateTime;
		}
		break;
	case TSENG_CALLBACK_STREAM_RESET:
		{			
			// Xg[Zbg			
			if(m_pFilterWnd) m_pFilterWnd->DeleteAllItems();
			if(m_pScheduleRec)
			{
				m_pScheduleRec->PutNetworkID(0);
				m_pScheduleRec->PutStreamID(wStreamID);
			}
			if(dwVal)
			{
				// Xg[I(͓ɏȂ)
			}
		}
		break;
	case TSENG_CALLBACK_PAT_RECIEVE:
		{
			// T[rXǉ
			struct TAG_TSCB_PATITEM *pstPatItem=(struct TAG_TSCB_PATITEM *)pData;
			for(unsigned int i=0;i<dwVal;i++)
			{
				if(m_pFilterWnd) m_pFilterWnd->AddService(pstPatItem[i].wProgramID,pstPatItem[i].wPID);
			}
		}
		break;
	case TSENG_CALLBACK_PMT_RECIEVE:
		{
			struct TAG_TSCB_PMTITEM *pstPmtItem=(struct TAG_TSCB_PMTITEM*)pData;
			struct FILTWND_PMTITEM *pSetData = new struct FILTWND_PMTITEM[dwVal];			
			if(pSetData)
			{
				struct SCHEDULE_PMTITEM *pSetData2 = new struct SCHEDULE_PMTITEM[dwVal];
				if(pSetData2)
				{
					for(unsigned int i=0;i<dwVal;i++)
					{
						pSetData[i].byType = pstPmtItem[i].byType;
						pSetData[i].wPID = pstPmtItem[i].wPID;
						pSetData2[i].byType = pstPmtItem[i].byType;
						pSetData2[i].wPID = pstPmtItem[i].wPID;
					}
					if(m_pFilterWnd) m_pFilterWnd->SetPMT(wStreamID,pSetData,dwVal);
					if(m_pScheduleRec) m_pScheduleRec->PutPID(wStreamID,pSetData2,dwVal);
					delete []pSetData2;
				}
				delete []pSetData;
			}
		}
		break;
	case TSENG_CALLBACK_NIT_RECIEVE:
		{
			if(m_pScheduleRec) m_pScheduleRec->PutNetworkID(wStreamID);
		}
		break;
	case TSENG_CALLBACK_SATELLITE_INFO:
		{
			struct TAG_TSCB_SATELLITE *pstSatellite = (struct TAG_TSCB_SATELLITE*)pData;
		}
		break;
	case TSENG_CALLBACK_SDT_RECIEVE:
		{
			if(m_pFilterWnd)
			{
				m_pFilterWnd->SetServiceName(wStreamID,(char*)pData);
			}
		}
		break;
	case TSENG_CALLBACK_EIT_PF_RECIEVE:
	case TSENG_CALLBACK_EIT_SCHEDULE_RECIEVE:
		{
			struct TSEPG_PROGRAM *pstProg = (struct TSEPG_PROGRAM*)pData;
			if(m_pFilterWnd)
			{
				m_pFilterWnd->SetEPG_PF(wStreamID,pstProg,dwVal);
			}
		}
		break;
	}
}