#include "stdafx.h"
#include "ChannelWnd.h"
#include "resource.h"

CChannelWnd::CChannelWnd(CDTV_Base *pDtvObj)
{
	m_pDtvObj = pDtvObj;
	m_iLastSelChNo = 0;
}

CChannelWnd::~CChannelWnd(void)
{
}


BOOL CChannelWnd::Create(HINSTANCE hInst,int iResource,HWND hParentWnd,BOOL bNoPosSize,int x,int y,int sx,int sy,int iShowMode)
{
	m_hWnd=CreateDialogParam(hInst,MAKEINTRESOURCE(iResource),hParentWnd,(DLGPROC)_ChannelDlg,(LPARAM)this);
	if(!bNoPosSize)
	{
		SetWindowPos(m_hWnd,0,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
	}
	ShowWindow(iShowMode);
	return TRUE;
}

void CChannelWnd::Destroy(int *pX ,int *pY,int *pSX,int *pSY,BOOL *pbShow)
{
	if(m_hWnd)
	{
		RECT rcRect;
		GetWindowRect(m_hWnd,&rcRect);
		if(pbShow) *pbShow=IsWindowVisible();
		if(pX) *pX=rcRect.left;
		if(pY) *pY=rcRect.top;
		if(pSX)*pSX=rcRect.right-rcRect.left;
		if(pSY)*pSY=rcRect.bottom-rcRect.top;
		DestroyWindow(m_hWnd);
	}
}

// tB^p_CAO
LRESULT CChannelWnd::ChannelDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	CChannelWnd* pThis=this;

	switch (message)
	{
	case WM_INITDIALOG:
		{
			m_hWnd=hDlg;
			SetEnable(FALSE);
			return TRUE;
		}
		break;
	case WM_DESTROY:
		{
		}
		break;
	case WM_CLOSE:
		{
			ShowWindow(SW_HIDE);
		}
		break;
	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{
			case IDC_CHANNEL:
				{
					if(HIWORD(wParam)==CBN_SELCHANGE)
					{
						// ύX{^V݂ɔp~\
						/*
						if(m_pDtvObj)
						{
							if(m_pDtvObj->GetExtFunction()&DTV_EXTFUNC_CHSEL)
							{
								LRESULT pos=SendDlgItemMessage(hDlg,IDC_CHANNEL,CB_GETCURSEL,0,0);
								if(pos==CB_ERR) break;
								LRESULT val=SendDlgItemMessage(hDlg,IDC_CHANNEL,CB_GETITEMDATA,pos,0);						
								if(m_pDtvObj->SetChannel((int)val))
								{
									m_iLastSelChNo = (int)val;
								}
							}
						}*/
					}
				}
				break;
			case IDC_CHANGE:
				{
					if(m_pDtvObj)
					{
						if(m_pDtvObj->GetExtFunction()&DTV_EXTFUNC_CHSEL)
						{
							LRESULT pos=SendDlgItemMessage(hDlg,IDC_CHANNEL,CB_GETCURSEL,0,0);
							if(pos==CB_ERR) break;
							LRESULT val=SendDlgItemMessage(hDlg,IDC_CHANNEL,CB_GETITEMDATA,pos,0);						
							if(m_pDtvObj->SetChannel((int)val))
							{
								m_iLastSelChNo = (int)val;
							}
						}
					}
				}
				break;
			case IDC_SEND:
				{
					if(m_pDtvObj)
					{
						if(m_pDtvObj->GetExtFunction()&DTV_EXTFUNC_CHSTR)
						{
							char buf[80];
							GetDlgItemText(hDlg,IDC_STRING,buf,80);
							m_pDtvObj->SetChannnelByString(buf);
						}
					}
				}
				break;
			}
		}
		break;
	case WM_CHANNELWND_LISTUPDATE:
		{
			int iChCount=0;
			SendDlgItemMessage(hDlg,IDC_CHANNEL,CB_RESETCONTENT,0,0);
			if(wParam==0 && m_pDtvObj)
			{
				if(m_pDtvObj->GetExtFunction()&DTV_EXTFUNC_CHSEL)
				{
					int i,n=m_pDtvObj->GetChannelCount();
					for(i=0;i<n;i++)
					{
						char buf[128];
						int val=m_pDtvObj->GetChannelName(i,buf,128);
						if(val!=-1)
						{
							LRESULT pos=SendDlgItemMessage(hDlg,IDC_CHANNEL,CB_ADDSTRING,0,(LPARAM)buf);
							SendDlgItemMessage(hDlg,IDC_CHANNEL,CB_SETITEMDATA,pos,val);
							if(i==0 || lParam ==val)
							{
								SendDlgItemMessage(hDlg,IDC_CHANNEL,CB_SETCURSEL,pos,0);
							}
							iChCount++;
						}
					}
				}
			}
		}
		break;
	}
	return FALSE;
}

// L/؂ւ
void CChannelWnd::SetEnable(BOOL bEnable)
{
	BOOL bFlg;
	bFlg=bEnable && m_pDtvObj->GetExtFunction()&DTV_EXTFUNC_CHSEL;
	EnableWindow(GetDlgItem(m_hWnd,IDC_CHANNEL),bFlg);
	EnableWindow(GetDlgItem(m_hWnd,IDC_CHANGE),bFlg);
	bFlg=bEnable && m_pDtvObj->GetExtFunction()&DTV_EXTFUNC_CHSTR;
	EnableWindow(GetDlgItem(m_hWnd,IDC_STRING),bFlg);
	EnableWindow(GetDlgItem(m_hWnd,IDC_SEND),bFlg);
}

// `lXgXV
void CChannelWnd::UpdateChannelList(BOOL bEraseOnly,int iSetChNo)
{
	PostMessage(m_hWnd,WM_CHANNELWND_LISTUPDATE,bEraseOnly?1:0,iSetChNo);
}