// File͗p(ɃfobOprBGUIɃt@CXg[𗬂)

#include "../StdAfx.h"
#include "DTV_FileIn.h"

#define FILE_POSITION_OFFSET (__int64)((long double)0);

CDTV_FileIn::CDTV_FileIn() : CDTV_Base()
{
	m_hFile=INVALID_HANDLE_VALUE;
	m_bOpen=FALSE;
}

CDTV_FileIn::~CDTV_FileIn(void)
{
	if(IsInitialized()) Release();
}


BOOL CDTV_FileIn::Initialize(char *szInitString,HWND hWnd,GUID *pGuid)
{
	if(IsInitialized()) return FALSE;

	m_hFile=CreateFile(szInitString,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	return m_hFile!=INVALID_HANDLE_VALUE?TRUE:FALSE;
}

void CDTV_FileIn::Release()
{
	DisConnect();
	if(IsInitialized())
	{
		CloseHandle(m_hFile);
		m_hFile=INVALID_HANDLE_VALUE;
	}
}

BOOL CDTV_FileIn::IsInitialized()
{
	return m_hFile!=INVALID_HANDLE_VALUE?TRUE:FALSE;
}

DWORD CDTV_FileIn::GetExtFunction()
{
	return DTV_EXTFUNC_NONE;
}

DWORD CDTV_FileIn::GetDeviceCount()
{
	if(!IsInitialized()) return 0;
	return 1;
}

BOOL CDTV_FileIn::GetDeviceName(int iDevNo,char *lpszDevName,int iBufLen)
{
	if(!IsInitialized()) return FALSE;
	lstrcpyn(lpszDevName,"File Reader",iBufLen);
	return TRUE;
}

DWORD CDTV_FileIn::GetUsbEndpointCount(int iDevNo)
{
	if(!IsInitialized()) return 0;
	return 2;
}

// _~[(Ƃ肠AddressAttributeȊOQƂĂȂ̂)
BOOL CDTV_FileIn::GetUsbEndpointInfo(int iDevNo,int iUsbEpNo,struct DTV_UsbEndpointInfo *pUsbEpInfo)
{
	if(!IsInitialized()) return FALSE;

	pUsbEpInfo->DscLen=0x07;
	pUsbEpInfo->DscType=0x05;
	pUsbEpInfo->Address=(iUsbEpNo==0?0x81:0x02);
	pUsbEpInfo->Attributes=0x02;
	pUsbEpInfo->MaxPktSize=0x200;
	pUsbEpInfo->PktsPerFrame=0xbaad;
	pUsbEpInfo->Interval=0x00;
	pUsbEpInfo->TimeOut=0x2710;
	pUsbEpInfo->UsbdStatus=0xbaadf00d;
	pUsbEpInfo->NtStatus=0xbaadf00d;

	return TRUE;
}

BOOL CDTV_FileIn::IsEndpointEffective(int iDevNo,int iUsbEpAddr)
{
	if(!IsInitialized()) return FALSE;
	return TRUE;
}

BOOL CDTV_FileIn::Connect(int iDevNo,int iInEpAddr,int iOutEpAddr)
{
	if(!IsInitialized()) return FALSE;
	if(IsConnect()) return FALSE;

	struct DTV_ThreadParam *pReq=NULL;
	struct DTV_ThreadParam *pRes=NULL;
	try
	{
		pReq=new struct DTV_ThreadParam;
		if(!pReq) throw 101;
		ZeroMemory(pReq,sizeof(struct DTV_ThreadParam));
		pReq->pClassPtr=this;
		m_stThread.hExitEvent=pReq->hExitEvent=CreateEvent(NULL,TRUE,FALSE,NULL);
		if(!m_stThread.hExitEvent) throw 102;

		m_bOpen=TRUE;

		// t@CʒuItZbg
		LARGE_INTEGER NewPos;
		NewPos.QuadPart=(__int64)FILE_POSITION_OFFSET;
		BOOL bSuccess=SetFilePointerEx(m_hFile,NewPos,NULL,FILE_BEGIN);
		
		m_stThread.stRequest.hThread=CreateThread(NULL,0,XferRequestThreadEntry,pReq,CREATE_SUSPENDED,&m_stThread.stRequest.dwThreadID);
		if(!m_stThread.stRequest.hThread)
		{
			throw 501;
		}

		// Jn
		ResumeThread(m_stThread.stRequest.hThread);
	}
	catch(int err_code)
	{
		DTV_CATCH_INT_ERROR_CODE(err_code);
	}
	return TRUE;
}

void CDTV_FileIn::DisConnect()
{
	if(IsConnect())
	{
		SetEvent(m_stThread.hExitEvent);
		if(WaitForSingleObject(m_stThread.hExitEvent,10*1000)!=WAIT_OBJECT_0)
		{
			// ^CAEgȂ̂ŋ~
			TerminateThread(m_stThread.stRequest.hThread,0xffffffff);
		}
		DWORD dwExitCode;
		GetExitCodeThread(m_stThread.stRequest.hThread,&dwExitCode);

		m_bOpen=FALSE;
	}
}

BOOL CDTV_FileIn::IsConnect()
{
	if(!IsInitialized()) return FALSE;
	return m_bOpen;
}

DWORD CDTV_FileIn::XferRequestProc(struct DTV_ThreadParam *lpParameter)
{
	BYTE *pBuf=new BYTE[DTV_FILEIN_DATA_READ_SIZE];
	double dWait=(DTV_FILEIN_DATA_READ_SIZE*1000.0)/DTV_FILEIN_DATA_PAR_SEC;
	if(pBuf)
	{
		// NGXg[v
		while(WaitForSingleObject(lpParameter->hExitEvent,0)!=WAIT_OBJECT_0)
		{
			DWORD dwRead;
			ReadFile(m_hFile,pBuf,DTV_FILEIN_DATA_READ_SIZE,&dwRead,NULL);
			if(dwRead>0)
			{
				m_stTransferInfo.ui64RecvTotal+=dwRead;
				DoDTVDataCallback(pBuf,dwRead,m_stTransferInfo.ui64RecvTotal);
				m_stTransferInfo.dwSuccess++;
			} else {
				DoDTVDataCallback(pBuf,0,m_stTransferInfo.ui64RecvTotal);
				m_stTransferInfo.dwFail++;
			}
			Sleep((DWORD)dWait);
		}
		delete []pBuf;
	}

	// I
	delete lpParameter;
	ExitThread(1);
	return 0;
}
